message twice  [val0==val1]
message thrice [val0==val1 * val1==val2]

contract C {
  initial final state start { !twice -> end; }
  state end { ?thrice -> start; }
}

test() {
  local e,f,x,y,a,b,c;

  (e,f) = open(C);
  send(twice,e,0,0);
  (x,y) = receive(twice,f);
  send(thrice,f,0,0,0);
  switch receive {
      (a,b,c) = receive(thrice,e): {}
    }
  if (x != y) { dispose(0); }
  if (a != b) { dispose(0); }
  if (b != c) { dispose(0); }
  close(e,f);
}
